diff --git a/src/haproxy.c b/src/haproxy.c
index 87f68432837c..bff26f505902 100644
--- a/src/haproxy.c
+++ b/src/haproxy.c
@@ -3268,6 +3268,8 @@ int main(int argc, char **argv)
 					exit(1); /* there has been an error */
 				}
 				else if (ret == 0) { /* child breaks here */
+                                        /* This one must not be exported, it's internal! */
+                                        unsetenv("HAPROXY_MWORKER_REEXEC");
 					ha_random_jump96(relative_pid);
 					break;
 				}
diff --git a/src/mworker-prog.c b/src/mworker-prog.c
index ba52406e9a45..10dc2da9f7ea 100644
--- a/src/mworker-prog.c
+++ b/src/mworker-prog.c
@@ -91,6 +91,8 @@ int mworker_ext_launch_all()
 				mworker_cleanlisteners();
 				mworker_cleantasks();
 
+				/* This one must not be exported, it's internal! */
+				unsetenv("HAPROXY_MWORKER_REEXEC");
 				execvp(child->command[0], child->command);
 
 				ha_alert("Cannot execute %s: %s\n", child->command[0], strerror(errno));
